#include "newaccountdialog.h"
#include <QFormLayout>
#include <QDebug>
#include <QSettings>
//#include <QMaemo5InformationBox>

NewAccountDialog::NewAccountDialog(QWidget *parent)
{
    this->setWindowTitle(tr("Add account"));

    mKeyLineEdit = new QLineEdit;
    mIpLineEdit = new QLineEdit;
    mPortLineEdit = new QLineEdit;
    mPortLineEdit->setText("8080");
    mPortLineEdit->setReadOnly(false);

    mButtonBox = new QDialogButtonBox;
    mButtonBox->addButton(QDialogButtonBox::Save);
    mButtonBox->addButton(QDialogButtonBox::Cancel);

    connect(mButtonBox, SIGNAL(accepted()), this, SLOT(save()));
    connect(mButtonBox, SIGNAL(rejected()), this, SLOT(reject()));

    QFormLayout *layout = new QFormLayout;
    layout->expandingDirections();
    layout->addRow(tr("Name:"), mKeyLineEdit);
    layout->addRow(tr("Ip:"), mIpLineEdit);
    layout->addRow(tr("Port:"), mPortLineEdit);
    layout->addWidget(mButtonBox);

    setLayout(layout);
}

void NewAccountDialog::save()
{
    QString myKey = mKeyLineEdit->text();
    QString myIp = mIpLineEdit->text();
    QString myPort = mPortLineEdit->text();

    QSettings settings;
    settings.beginGroup("account");
    if (!mEditKey.isEmpty()) {
        settings.remove(mEditKey);
    }

    if (!myIp.isEmpty() && !myKey.isEmpty()) {
        if (myPort.isEmpty()) {
            myPort = "8080";
        }
        settings.setValue(myKey, myIp+":"+myPort);
        // Rajouter des tests pour vérifier qu'on est sur Maemo
        //QMaemo5InformationBox::information(this, tr("Account saved"), QMaemo5InformationBox::DefaultTimeout);
    }
    settings.endGroup();

    emit accept();
}

void NewAccountDialog::edit(QString &key, QString &ip)
{
    this->setWindowTitle(tr("Edit account"));

    QSettings settings;
    settings.beginGroup("account");
    QString value = settings.value(key).toString();
    settings.endGroup();

    QStringList values = value.split(":");

    mEditKey = key;
    mEditIp = values.first();
    mEditPort = values.last();

    mKeyLineEdit->setText(mEditKey);
    mKeyLineEdit->setDisabled(true);
    mIpLineEdit->setText(mEditIp);
    mPortLineEdit->setText(mEditPort);
}

